/*-------------------------------------------------------------------------+
| Copyright 2023 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.ext.quality.data;

import java.util.HashMap;
import java.util.Map;

import org.fortiss.tooling.ext.quality.HierarchicElementProvider;

/**
 * Class for storing data generated by the {@link HierarchicElementProvider}
 * 
 * @author groh
 */
public class HierarchicalMetricDataContainer implements IMetricDataContainer {

	/** Map containing all metrics which are a double */
	private Map<String, Double> storedMetrics = new HashMap<>();

	/** name of the element which is associated with this data */
	private String name;

	/**
	 * @return the name of the element which is associated with this data
	 */
	public String getName() {
		return name;
	}

	/** Set the name */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the stored metrics map
	 */
	public Map<String, Double> getStoredMetrics() {
		return storedMetrics;
	}
}
